function plotLinearTransformation2D(A )
% function that will plot the application of A to a set of unitary vectors
% input A a 2x2 matrix

    % number of samples
    n = 100;
    %create unitary vectors 
    theta = linspace(0,2*pi,n);
    X = [cos(theta);...
         sin(theta)];

    % multiply by A
    Y = A*X;

    % plot both set of vectors in the same window
    figure(1); clf() % open a new graphic window an clean it
    plot(X(1,:)',X(2,:)');
    hold on;         % so you can plot over in the same window
    plot(Y(1,:)',Y(2,:)', 'r');
    axis equal

end

