function x = solveLinearSystem(A,b )
% function to solve the linear systen Ax = b using Gaussian elimination
% input A : matrix mxn (for this function you can suppose m=n)
%       b : vector  m vector
% output x solution to Ax = b

% test that the sizes are consistent
[m,n] = size(A);

% create the augmented matrix 
B = [A b];
% row reduce the augmented matrix to echelon form
% you can suppose that you won't need to swap any rows
for j = 1:n
    if B(j,j) == 0
        error('Matrix is singular! \n');
    end
    B(j,:) = B(j,:)/B(j,j); % normalize 
    % we are eliminating entries below the diagonal
    B(j+1:n,:) = B(j+1:n,:) - B(j+1:n,j)*B(j,:);
end

% consistent? (if it is not display an error message)

% row reduces the augmented matrix to reduced echelon form

    % we go from the bottom to the top of the matrix
for j = n:-1:1
    % no need to normalize
    % we are eliminating entries above the diagonal
    % (check how is different from the one before)
    B(1:j-1,:) = B(1:j-1,:) - B(1:j-1,j)*B(j,:);
end

% if everything is ok, return the solution :)
x = B(:,n+1);

end

